#!/usr/bin/env python
# -*- coding: utf-8 -*-
# __coconut_hash__ = 0xf261ebf4

# Compiled with Coconut version 1.4.0-post_dev7 [Ernest Scribbler]

"""
Backends contains all of bbopt's different backends.
"""

# Coconut Header: -------------------------------------------------------------

from __future__ import print_function, absolute_import, unicode_literals, division
import sys as _coconut_sys, os.path as _coconut_os_path
_coconut_file_path = _coconut_os_path.dirname(_coconut_os_path.abspath(__file__))
_coconut_cached_module = _coconut_sys.modules.get(str("__coconut__"))
if _coconut_cached_module is not None and _coconut_os_path.dirname(_coconut_cached_module.__file__) != _coconut_file_path:
    del _coconut_sys.modules[str("__coconut__")]
_coconut_sys.path.insert(0, _coconut_file_path)
from __coconut__ import _coconut, _coconut_MatchError, _coconut_igetitem, _coconut_base_compose, _coconut_forward_compose, _coconut_back_compose, _coconut_forward_star_compose, _coconut_back_star_compose, _coconut_pipe, _coconut_star_pipe, _coconut_back_pipe, _coconut_back_star_pipe, _coconut_bool_and, _coconut_bool_or, _coconut_none_coalesce, _coconut_minus, _coconut_map, _coconut_partial, _coconut_get_function_match_error, _coconut_addpattern, _coconut_sentinel
from __coconut__ import *
_coconut_sys.path.remove(_coconut_file_path)

# Compiled Coconut: -----------------------------------------------------------



class Registry(_coconut.object):
    """Registry that keeps track of registered objects."""

    def __init__(self, obj_name="obj", defaults=None, generators={}, aliases={}):
        self.obj_name = obj_name
        self.registered = {} if defaults is None else defaults
        self.generators = generators
        self.aliases = aliases

    def __getitem__(self, name):
        name = self.aliases.get(name, name)
        _coconut_match_to = self.registered
        _coconut_match_check = False
        if _coconut.isinstance(_coconut_match_to, _coconut.abc.Mapping):
            _coconut_match_temp_0 = _coconut_match_to.get(name, _coconut_sentinel)
            if _coconut_match_temp_0 is not _coconut_sentinel:
                value = _coconut_match_temp_0
                _coconut_match_check = True
        if _coconut_match_check:
            return self.registered[name]
        else:
            _coconut_match_to = self.generators
            _coconut_match_check = False
            if _coconut.isinstance(_coconut_match_to, _coconut.abc.Mapping):
                _coconut_match_temp_0 = _coconut_match_to.get(name, _coconut_sentinel)
                if _coconut_match_temp_0 is not _coconut_sentinel:
                    gen = _coconut_match_temp_0
                    _coconut_match_check = True
            if _coconut_match_check:
                value = gen()
                self.register(name, value)
                return value
            else:
                raise ValueError("unknown {obj_name}: {name} (valid {obj_name}s: {valid_names})".format(obj_name=self.obj_name, name=name, valid_names=", ".join((repr(name) for name in self))))

    def __iter__(self):
        _coconut_yield_from = self.registered
        for _coconut_yield_item in _coconut_yield_from:
            yield _coconut_yield_item

        for name in self.generators:
            if name not in self.registered:
                yield name

    def items(self):
        _coconut_yield_from = self.registered.items()
        for _coconut_yield_item in _coconut_yield_from:
            yield _coconut_yield_item

        for name in self.generators:
            yield name, self[name]

    def register(self, name, value):
        """Register value under the given name."""
        self.registered[name] = value


def _coconut_lambda_0(_=None):
    from bbopt.backends.serving import ServingBackend
    return ServingBackend
def _coconut_lambda_1(_=None):
    from bbopt.backends.random import RandomBackend
    return RandomBackend
def _coconut_lambda_2(_=None):
    from bbopt.backends.skopt import SkoptBackend
    return SkoptBackend
def _coconut_lambda_3(_=None):
    from bbopt.backends.hyperopt import HyperoptBackend
    return HyperoptBackend
backend_registry = Registry(obj_name="backend", generators={"serving": (_coconut_lambda_0), "random": (_coconut_lambda_1), "scikit-optimize": (_coconut_lambda_2), "hyperopt": (_coconut_lambda_3)}, aliases={None: "serving"})


def init_backend(name, examples, params, **kwargs):
    """Create a backend object of the given name with the given data."""
    return backend_registry[name](examples, params, **kwargs)


def _coconut_lambda_4(_=None):
    from hyperopt import anneal
    return ("hyperopt", dict(algo=anneal.suggest))
alg_registry = Registry(obj_name="algorithm", defaults={"serving": ("serving", {}), "random": ("random", {}), "gaussian_process": ("scikit-optimize", {}), "random_forest": ("scikit-optimize", dict(base_estimator="RF")), "extra_trees": ("scikit-optimize", dict(base_estimator="ET")), "gradient_boosted_regression_trees": ("scikit-optimize", dict(base_estimator="GBRT")), "tree_structured_parzen_estimator": ("hyperopt", {})}, generators={"annealing": (_coconut_lambda_4)}, aliases={None: "serving"})
